unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ColorEdt;

type
  TForm1 = class(TForm)
    ColorEdit1: TColorEdit;
    ColorEdit2: TColorEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure ColorEdit1GetSymbolColor(Sender: TObject; Ch: Char;
      Index: Integer; Selected: Boolean; var TextColor, BkColor: TColor);
    procedure ColorEdit1AfterExit(Sender: TObject);
    procedure ColorEdit2Change(Sender: TObject);
    procedure ColorEdit2GetSymbolColor(Sender: TObject; Ch: Char;
      Index: Integer; Selected: Boolean; var TextColor, BkColor: TColor);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    TextColors: array[1..255] of TColor;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ColorEdit1GetSymbolColor(Sender: TObject; Ch: Char;
  Index: Integer; Selected: Boolean; var TextColor, BkColor: TColor);
begin
  if not ColorEdit1.Enabled then begin
    TextColor := clGray;
    Exit;
  end;

  if not Selected then begin
    if Ch in ['a'..'z', 'A'..'Z']  then
      TextColor := clRed;
  end else begin
    TextColor := clWhite;
    BkColor := clTeal;
  end;
end;

procedure TForm1.ColorEdit1AfterExit(Sender: TObject);
var
  I: Longint;
begin
  if not Active or ColorEdit1.Focused then Exit;

  with ColorEdit1 do
    for I := 1 to Length(Text) do
      if Text[i] in ['a'..'z', 'A'..'Z'] then begin
        ShowMessage('      . ');
        SetFocus;
        break;
      end;
end;

procedure TForm1.ColorEdit2Change(Sender: TObject);
var
  S: String;
  I, P: Longint;
begin
  S := (Sender as TColorEdit).Text;

  for I := 1 to Length(S) do
    TextColors[I] := clBlack;

  P := Pos('mod', S);
  if P > 0 then
    for I := P to P+2 do
      TextColors[I] := clBlue;
  P := Pos('div', S);
  if P > 0 then
    for I := P to P+2 do
      TextColors[I] := clBlue;
  P := Pos(':=', S);
  if P > 0 then
    for I := P to P+1 do
      TextColors[I] := clRed;
end;

procedure TForm1.ColorEdit2GetSymbolColor(Sender: TObject; Ch: Char;
  Index: Integer; Selected: Boolean; var TextColor, BkColor: TColor);
begin
  TextColor := TextColors[Index];
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Caption := 'TColorEditor v' + ColorEdit1.Version +
             ' (C)  .. 1998';
end;

end.
