unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, DBColMem, StdCtrls, RXCtrls, Buttons, ColorMem;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    ColorMemo1: TColorMemo;
    ScrollBox1: TScrollBox;
    ckBorderStyle: TCheckBox;
    cbColor: TColorComboBox;
    cbDisableColorText: TColorComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    cbDisableColorBack: TColorComboBox;
    Label4: TLabel;
    ckEnabled: TCheckBox;
    Label5: TLabel;
    sbFont: TSpeedButton;
    Label6: TLabel;
    f_Font: TFontDialog;
    ckHideSelection: TCheckBox;
    Label7: TLabel;
    ckReadOnly: TCheckBox;
    Label8: TLabel;
    edMaxLength: TEdit;
    Label9: TLabel;
    rgScrollBars: TRadioGroup;
    Label10: TLabel;
    cbSelectColorText: TColorComboBox;
    Label11: TLabel;
    cbSelectColorBack: TColorComboBox;
    Label12: TLabel;
    cbTextColorText: TColorComboBox;
    cbTextColorBack: TColorComboBox;
    Label13: TLabel;
    Label14: TLabel;
    ckWantReturns: TCheckBox;
    ckWordWrap: TCheckBox;
    Label15: TLabel;
    Label16: TLabel;
    procedure ColorMemo1GetSymbolColor(Sender: TObject; Ch: Char; Row,
      Col: Integer; Selected: Boolean; var TextColor, BkColor: TColor);
    procedure ckBorderStyleClick(Sender: TObject);
    procedure cbColorChange(Sender: TObject);
    procedure cbDisableColorTextChange(Sender: TObject);
    procedure cbDisableColorBackChange(Sender: TObject);
    procedure ckEnabledClick(Sender: TObject);
    procedure sbFontClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ckHideSelectionClick(Sender: TObject);
    procedure ckReadOnlyClick(Sender: TObject);
    procedure edMaxLengthKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure rgScrollBarsClick(Sender: TObject);
    procedure cbSelectColorTextChange(Sender: TObject);
    procedure cbSelectColorBackChange(Sender: TObject);
    procedure cbTextColorTextChange(Sender: TObject);
    procedure cbTextColorBackChange(Sender: TObject);
    procedure ckWantReturnsClick(Sender: TObject);
    procedure ckWordWrapClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ColorMemo1GetSymbolColor(Sender: TObject; Ch: Char; Row,
  Col: Integer; Selected: Boolean; var TextColor, BkColor: TColor);
begin
  if Selected or not ColorMemo1.Enabled then Exit;

  if Pos(AnsiLowerCase(Ch), '') > 0 then
    TextColor := clRed;
end;

procedure TForm1.ckBorderStyleClick(Sender: TObject);
begin
  if (Sender as TCheckBox).Checked then
    ColorMemo1.BorderStyle := bsSingle
  else
    ColorMemo1.BorderStyle := bsNone;
end;

procedure TForm1.cbColorChange(Sender: TObject);
begin
  ColorMemo1.Color := (Sender as TColorComboBox).ColorValue;
end;

procedure TForm1.cbDisableColorTextChange(Sender: TObject);
begin
  ColorMemo1.DisableColor.TextColor := (Sender as TColorComboBox).ColorValue;
end;

procedure TForm1.cbDisableColorBackChange(Sender: TObject);
begin
  ColorMemo1.DisableColor.BackColor := (Sender as TColorComboBox).ColorValue;
end;

procedure TForm1.ckEnabledClick(Sender: TObject);
begin
  ColorMemo1.Enabled := (Sender as TCheckBox).Checked;
end;

procedure TForm1.sbFontClick(Sender: TObject);
begin
  f_Font.Font := ColorMemo1.Font;
  if f_Font.Execute then begin
    ColorMemo1.Font := f_Font.Font;
    sbFont.Caption := ColorMemo1.Font.Name;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  sbFont.Caption := ColorMemo1.Font.Name;
  with ColorMemo1 do begin
    cbColor.ColorValue := Color;
    cbDisableColorText.ColorValue := DisableColor.TextColor;
    cbDisableColorBack.ColorValue := DisableColor.BackColor;
    cbSelectColorText.ColorValue := SelectColor.TextColor;
    cbSelectColorBack.ColorValue := SelectColor.BackColor;
    cbTextColorText.ColorValue := TextColor.TextColor;
    cbTextColorBack.ColorValue := TextColor.BackColor;
  end;
end;

procedure TForm1.ckHideSelectionClick(Sender: TObject);
begin
  ColorMemo1.HideSelection := (Sender as TCheckBox).Checked;
end;

procedure TForm1.ckReadOnlyClick(Sender: TObject);
begin
  ColorMemo1.ReadOnly := (Sender as TCheckBox).Checked;
end;

procedure TForm1.edMaxLengthKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then
    ColorMemo1.MaxLength := StrToInt(edMaxLength.Text);
end;

procedure TForm1.rgScrollBarsClick(Sender: TObject);
begin
  case (Sender as TRadioGroup).ItemIndex of
    0: ColorMemo1.ScrollBars := ssBoth;
    1: ColorMemo1.ScrollBars := ssHorizontal;
    2: ColorMemo1.ScrollBars := ssNone;
    3: ColorMemo1.ScrollBars := ssVertical;
  end;
end;

procedure TForm1.cbSelectColorTextChange(Sender: TObject);
begin
  ColorMemo1.SelectColor.TextColor := (Sender as TColorComboBox).ColorValue;
end;

procedure TForm1.cbSelectColorBackChange(Sender: TObject);
begin
  ColorMemo1.SelectColor.BackColor := (Sender as TColorComboBox).ColorValue;
end;

procedure TForm1.cbTextColorTextChange(Sender: TObject);
begin
  ColorMemo1.TextColor.TextColor := (Sender as TColorComboBox).ColorValue;
end;

procedure TForm1.cbTextColorBackChange(Sender: TObject);
begin
  ColorMemo1.TextColor.BackColor := (Sender as TColorComboBox).ColorValue;
end;

procedure TForm1.ckWantReturnsClick(Sender: TObject);
begin
  ColorMemo1.WantReturns := (Sender as TCheckBox).Checked;
end;

procedure TForm1.ckWordWrapClick(Sender: TObject);
begin
  ColorMemo1.WordWrap := (Sender as TCheckBox).Checked;
end;

end.
