unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ColorMem;

type
  TForm1 = class(TForm)
    ColorMemo1: TColorMemo;
    procedure ColorMemo1Change(Sender: TObject);
    procedure ColorMemo1GetSymbolColor(Sender: TObject; Ch: Char; Row,
      Col: Integer; Selected: Boolean; var TextColor, BkColor: TColor);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
const
  COLORS_SIZE = 2048;
  KEY_WORDS_COUNT = 10;
  CRLF = #13#10;


var
  SymbColors: array[1..COLORS_SIZE] of TColor;
  KeyWords: array[1..KEY_WORDS_COUNT] of String =( 'TCOLORMEMO',
                                                   'SELECT',
                                                   'UPDATE',
                                                   'DELETE',
                                                   'INSERT',
                                                   'SET',
                                                   'FROM',
                                                   'WHERE',
                                                   'AND',
                                                   'OR'
                                                  );

procedure TForm1.ColorMemo1Change(Sender: TObject);
const
  Colors: array[0..9] of TColor = (clPurple, clMaroon, clGray, clBlue, clRed,
                                   clLime, clTeal, clTeal, clTeal, clTeal);
var
  S: String;
  P: Longint;
  I, K, C: Longint;
  Len: Longint;
begin
  S := UpperCase(ColorMemo1.Text);
  while True do begin
    P := Pos(CRLF, S);
    if P > 0 then Delete(S, P, 2)
    else          break;
  end;

  I := 1;
  while I <= Length(S) do begin
    if I <= COLORS_SIZE then begin
      if (S[I] = '''') or (S[I] in ['0'..'9']) then
        SymbColors[I] := clGreen
      else
        SymbColors[I] := ColorMemo1.TextColor.TextColor;
    end;

    for K := 1 to KEY_WORDS_COUNT do begin
      Len := Length(KeyWords[K]);
      if Copy(S, I, Len) = KeyWords[K] then begin
        for C := I to I + Len - 1 do
          if C <= COLORS_SIZE then begin
            if K = 1 then
              SymbColors[C] := Colors[C-I]
            else if K <= 7 then
              SymbColors[C] := clRed
            else
              SymbColors[C] := clBlue;
          end;
        Inc(I, Len-1);
        break;
      end;
    end;
    Inc(I);
  end;
end;

procedure TForm1.ColorMemo1GetSymbolColor(Sender: TObject; Ch: Char; Row,
  Col: Integer; Selected: Boolean; var TextColor, BkColor: TColor);
var
  I, C: Longint;
  S: String;
  P: Longint;
begin
  if Selected then Exit;

  C := 0;
  for I := 0 to Row-1 do begin
    S := ColorMemo1.Lines[I];
    P := Pos(CRLF, S);
    if P > 0 then Delete(S, P, 2);
    C := C + Length(S);
  end;
  Inc(C, Col);

  if (C > 0) and (C <= COLORS_SIZE) then
    TextColor := SymbColors[C];
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Caption := 'TColorMemo v' + ColorMemo1.Version +
             ' (C)  . 1998';
end;

end.
